--[[ Container Frame ]]--
	local IWDOptionsPanel = CreateFrame("Frame", "IWDConfig", InterfaceOptionsFramePanelContainer)
	IWDOptionsPanel:Hide()
	IWDOptionsPanel.name = "IWD"
	InterfaceOptions_AddCategory(IWDOptionsPanel)

	local title = IWDOptionsPanel:CreateFontString("IWDConfigTitle", "ARTWORK", "GameFontNormalLarge")
	title:SetPoint("TOPLEFT", 16, -16)
	title:SetText("IWD (Improved World Defense)")
--[[ End Container Frame ]]--


------- Enable/Disable Addon --------
	local chkEnable = CreateFrame("CheckButton", "IWDBtnEnable", IWDOptionsPanel)
	chkEnable:SetWidth(26)
	chkEnable:SetHeight(26)
	chkEnable:SetPoint("TOPLEFT", 16, -52)
	
	-- OnShow
	chkEnable:SetScript("OnShow", function(frame)
		if IWDConfiguration.ENABLE then
			frame:SetChecked(true)
		else
			frame:SetChecked(false)
		end
	end)
	-- OnClick
	chkEnable:SetScript("OnClick", function(frame)
		local tick = frame:GetChecked()
		if tick then
			PlaySound("igMainMenuOptionCheckBoxOn")
			IWDConfiguration.ENABLE = true
		else
			PlaySound("igMainMenuOptionCheckBoxOff")
			IWDConfiguration.ENABLE = false
		end
	end)
	-- OnEnter
	chkEnable:SetScript("OnEnter", function(frame)
		GameTooltip:SetOwner(frame, "ANCHOR_CURSOR");
		GameTooltip:SetBackdropColor(TOOLTIP_DEFAULT_BACKGROUND_COLOR.r, TOOLTIP_DEFAULT_BACKGROUND_COLOR.g, TOOLTIP_DEFAULT_BACKGROUND_COLOR.b);
		GameTooltip:SetText("Enable/Disable the addon.", 1.0, 1.0, 1.0);
	end)
	-- OnLeave
	chkEnable:SetScript("OnLeave", function(frame)
		GameTooltip:Hide()
	end)
	chkEnable:SetHitRectInsets(0, -100, 0, 0)

	chkEnable:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up")
	chkEnable:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down")
	chkEnable:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight")
	chkEnable:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check")

	local chkEnableText = chkEnable:CreateFontString("IWDConfigButton1Title", "ARTWORK", "GameFontHighlight")
	chkEnableText:SetPoint("LEFT", chkEnable, "RIGHT", 0, 1)
	chkEnableText:SetText("Enable IWD")

------- Enable/Disable Sound --------
	local chkSound = CreateFrame("CheckButton", "IWDBtnSound", IWDOptionsPanel)
	chkSound:SetWidth(26)
	chkSound:SetHeight(26)
	chkSound:SetPoint("TOPLEFT", chkEnable, "BOTTOMLEFT")
	
	-- OnShow
	chkSound:SetScript("OnShow", function(frame)
		if IWDConfiguration.SOUND then
			frame:SetChecked(true)
		else
			frame:SetChecked(false)
		end
	end)
	-- OnClick
	chkSound:SetScript("OnClick", function(frame)
		local tick = frame:GetChecked()
		if tick then
			PlaySound("igMainMenuOptionCheckBoxOn")
			IWDConfiguration.SOUND = true
			PlaySound(IWDConfiguration.ALERT);
		else
			PlaySound("igMainMenuOptionCheckBoxOff")
			IWDConfiguration.SOUND = false
		end
	end)
	-- OnEnter
	chkSound:SetScript("OnEnter", function(frame)
		GameTooltip:SetOwner(frame, "ANCHOR_CURSOR");
		GameTooltip:SetBackdropColor(TOOLTIP_DEFAULT_BACKGROUND_COLOR.r, TOOLTIP_DEFAULT_BACKGROUND_COLOR.g, TOOLTIP_DEFAULT_BACKGROUND_COLOR.b);
		GameTooltip:SetText("Enable/Disable audio warning\nwhen an area is attacked heavily.", 1.0, 1.0, 1.0);
	end)
	-- OnLeave
	chkSound:SetScript("OnLeave", function(frame)
		GameTooltip:Hide()
	end)
	chkSound:SetHitRectInsets(0, -100, 0, 0)

	chkSound:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up")
	chkSound:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down")
	chkSound:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight")
	chkSound:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check")

	local chkSoundText = chkSound:CreateFontString("IWDConfigButton1Title", "ARTWORK", "GameFontHighlight")
	chkSoundText:SetPoint("LEFT", chkSound, "RIGHT", 0, 1)
	chkSoundText:SetText("Enable Audio Alert")

------- Enable/Disable Subzone Naming --------
	local chkSubzone = CreateFrame("CheckButton", "IWDBtnSubzone", IWDOptionsPanel)
	chkSubzone:SetWidth(26)
	chkSubzone:SetHeight(26)
	chkSubzone:SetPoint("TOPLEFT", chkSound, "BOTTOMLEFT")
	
	-- OnShow
	chkSubzone:SetScript("OnShow", function(frame)
		if IWDConfiguration.SUBZONES then
			frame:SetChecked(true)
		else
			frame:SetChecked(false)
		end
	end)
	-- OnClick
	chkSubzone:SetScript("OnClick", function(frame)
		local tick = frame:GetChecked()
		if tick then
			PlaySound("igMainMenuOptionCheckBoxOn")
			IWDConfiguration.SUBZONES = true
		else
			PlaySound("igMainMenuOptionCheckBoxOff")
			IWDConfiguration.SUBZONES = false
		end
	end)
	-- OnEnter
	chkSubzone:SetScript("OnEnter", function(frame)
		GameTooltip:SetOwner(frame, "ANCHOR_CURSOR");
		GameTooltip:SetBackdropColor(TOOLTIP_DEFAULT_BACKGROUND_COLOR.r, TOOLTIP_DEFAULT_BACKGROUND_COLOR.g, TOOLTIP_DEFAULT_BACKGROUND_COLOR.b);
		GameTooltip:SetText("Enables/Disables the use of full\nsubzone names in alert text.", 1.0, 1.0, 1.0);
	end)
	-- OnLeave
	chkSubzone:SetScript("OnLeave", function(frame)
		GameTooltip:Hide()
	end)
	chkSubzone:SetHitRectInsets(0, -100, 0, 0)

	chkSubzone:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up")
	chkSubzone:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down")
	chkSubzone:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight")
	chkSubzone:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check")

	local chkSubzoneText = chkSubzone:CreateFontString("IWDConfigButton1Title", "ARTWORK", "GameFontHighlight")
	chkSubzoneText:SetPoint("LEFT", chkSubzone, "RIGHT", 0, 1)
	chkSubzoneText:SetText("Enable Subzone Names")

------- Enable/Disable Chat Notification --------
	local chkMute = CreateFrame("CheckButton", "IWDBtnMute", IWDOptionsPanel)
	chkMute:SetWidth(26)
	chkMute:SetHeight(26)
	chkMute:SetPoint("TOPLEFT", chkSubzone, "BOTTOMLEFT")
	
	-- OnShow
	chkMute:SetScript("OnShow", function(frame)
		if IWDConfiguration.MUTE then
			frame:SetChecked(true)
		else
			frame:SetChecked(false)
		end
	end)
	-- OnClick
	chkMute:SetScript("OnClick", function(frame)
		local tick = frame:GetChecked()
		if tick then
			PlaySound("igMainMenuOptionCheckBoxOn")
			IWDConfiguration.MUTE = true
		else
			PlaySound("igMainMenuOptionCheckBoxOff")
			IWDConfiguration.MUTE = false
		end
	end)
	-- OnEnter
	chkMute:SetScript("OnEnter", function(frame)
		GameTooltip:SetOwner(frame, "ANCHOR_CURSOR");
		GameTooltip:SetBackdropColor(TOOLTIP_DEFAULT_BACKGROUND_COLOR.r, TOOLTIP_DEFAULT_BACKGROUND_COLOR.g, TOOLTIP_DEFAULT_BACKGROUND_COLOR.b);
		GameTooltip:SetText("Enables/Disables heavy attack\nchat notifications.", 1.0, 1.0, 1.0);
	end)
	-- OnLeave
	chkMute:SetScript("OnLeave", function(frame)
		GameTooltip:Hide()
	end)
	chkMute:SetHitRectInsets(0, -100, 0, 0)

	chkMute:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up")
	chkMute:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down")
	chkMute:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight")
	chkMute:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check")

	local chkMuteText = chkMute:CreateFontString("IWDConfigButton1Title", "ARTWORK", "GameFontHighlight")
	chkMuteText:SetPoint("LEFT", chkMute, "RIGHT", 0, 1)
	chkMuteText:SetText("Mute Chat Notifications")

------- Enable/Disable LDB-Only Mode --------
	local chkLDBOnly = CreateFrame("CheckButton", "IWDBtnLDBOnly", IWDOptionsPanel)
	chkLDBOnly:SetWidth(26)
	chkLDBOnly:SetHeight(26)
	chkLDBOnly:SetPoint("TOPLEFT", chkMute, "BOTTOMLEFT")
	
	-- OnShow
	chkLDBOnly:SetScript("OnShow", function(frame)
		if IWDConfiguration.LDBONLY then
			frame:SetChecked(true)
		else
			frame:SetChecked(false)
		end
	end)
	-- OnClick
	chkLDBOnly:SetScript("OnClick", function(frame)
		local tick = frame:GetChecked()
		if tick then
			PlaySound("igMainMenuOptionCheckBoxOn")
			IWDConfiguration.LDBONLY = true
		else
			PlaySound("igMainMenuOptionCheckBoxOff")
			IWDConfiguration.LDBONLY = false
		end
	end)
	-- OnEnter
	chkLDBOnly:SetScript("OnEnter", function(frame)
		GameTooltip:SetOwner(frame, "ANCHOR_CURSOR");
		GameTooltip:SetBackdropColor(TOOLTIP_DEFAULT_BACKGROUND_COLOR.r, TOOLTIP_DEFAULT_BACKGROUND_COLOR.g, TOOLTIP_DEFAULT_BACKGROUND_COLOR.b);
		GameTooltip:SetText("Enables/Disables showing IWD\nnotifications in your LDB\ndisplay manager only.", 1.0, 1.0, 1.0);
	end)
	-- OnLeave
	chkLDBOnly:SetScript("OnLeave", function(frame)
		GameTooltip:Hide()
	end)
	chkLDBOnly:SetHitRectInsets(0, -100, 0, 0)

	chkLDBOnly:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up")
	chkLDBOnly:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down")
	chkLDBOnly:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight")
	chkLDBOnly:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check")

	local chkLDBOnlyText = chkLDBOnly:CreateFontString("IWDConfigButton1Title", "ARTWORK", "GameFontHighlight")
	chkLDBOnlyText:SetPoint("LEFT", chkLDBOnly, "RIGHT", 0, 1)
	chkLDBOnlyText:SetText("LDB Only Mode")

------- Lock/Unlock IWD Frame --------
	local chkLock = CreateFrame("CheckButton", "IWDBtnLock", IWDOptionsPanel)
	chkLock:SetWidth(26)
	chkLock:SetHeight(26)
	chkLock:SetPoint("TOPLEFT", chkLDBOnly, "BOTTOMLEFT")
	
	-- OnShow
	chkLock:SetScript("OnShow", function(frame)
		if IWDConfiguration.LOCK then
			frame:SetChecked(true)
		else
			frame:SetChecked(false)
		end
	end)
	-- OnClick
	chkLock:SetScript("OnClick", function(frame)
		local tick = frame:GetChecked()
		if tick then
			PlaySound("igMainMenuOptionCheckBoxOn")
			IWDConfiguration.LOCK = true
			IWD.Msg("IWD","Alert frame LOCKED");
			IWDFrame:SetBackdrop(nil);
		else
			PlaySound("igMainMenuOptionCheckBoxOff")
			IWDConfiguration.LOCK = false
			IWD.Msg("IWD","Alert frame UNLOCKED");
			IWDFrame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", 
                                            edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
                                            tile = true, tileSize = 16, edgeSize = 16, 
                                            insets = { left = 4, right = 4, top = 4, bottom = 4 }});
											IWDFrame:SetBackdropColor(0,0,0,1);
		end
	end)
	-- OnEnter
	chkLock:SetScript("OnEnter", function(frame)
		GameTooltip:SetOwner(frame, "ANCHOR_CURSOR");
		GameTooltip:SetBackdropColor(TOOLTIP_DEFAULT_BACKGROUND_COLOR.r, TOOLTIP_DEFAULT_BACKGROUND_COLOR.g, TOOLTIP_DEFAULT_BACKGROUND_COLOR.b);
		GameTooltip:SetText("Lock/Unlocks the IWD Alert\nframe to allow you to position\nit anywhere onscreen.", 1.0, 1.0, 1.0);
	end)
	-- OnLeave
	chkLock:SetScript("OnLeave", function(frame)
		GameTooltip:Hide()
	end)
	chkLock:SetHitRectInsets(0, -100, 0, 0)

	chkLock:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up")
	chkLock:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down")
	chkLock:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight")
	chkLock:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check")

	local chkLockText = chkLock:CreateFontString("IWDConfigButton1Title", "ARTWORK", "GameFontHighlight")
	chkLockText:SetPoint("LEFT", chkLock, "RIGHT", 0, 1)
	chkLockText:SetText("Lock IWD Alert Frame")
	
------- Notification Interval Slider --------
	local sliderNotification = CreateFrame("Slider", "IWDSliderNotification", IWDOptionsPanel, 'OptionsSliderTemplate')
	sliderNotification:SetWidth(125)
	sliderNotification:SetHeight(20)
	sliderNotification:SetPoint("TOPLEFT", chkLock, "BOTTOMLEFT", 0, -30)
	
	-- OnShow
	sliderNotification:SetScript("OnShow", function(frame)
		sliderNotification.tooltipText = 'Sets the number of a times a location must be attacked before it will be considered under "heavy" attack' 
		sliderNotification:SetMinMaxValues(1,10);
		sliderNotification:SetValueStep(1);
		sliderNotification:SetOrientation('HORIZONTAL')
		sliderNotification:SetValue(IWDConfiguration.INTERVAL);
		getglobal(sliderNotification:GetName() .. 'Text'):SetText(sliderNotification:GetValue());
		sliderNotification:Enable();
	end)
	-- OnValueChanged
	sliderNotification:SetScript("OnValueChanged", function(frame)
		getglobal(sliderNotification:GetName() .. 'Text'):SetText(sliderNotification:GetValue());
		IWDConfiguration.INTERVAL = sliderNotification:GetValue();
	end)
	
------- Threshold Interval Slider --------
	local sliderThreshold = CreateFrame("Slider", "IWDSliderThreshold", IWDOptionsPanel, 'OptionsSliderTemplate')
	sliderThreshold:SetWidth(125)
	sliderThreshold:SetHeight(20)
	sliderThreshold:SetPoint("TOPLEFT", sliderNotification, "BOTTOMLEFT", 0, -30)
	
	-- OnShow
	sliderThreshold:SetScript("OnShow", function(frame)
		sliderThreshold.tooltipText = 'Sets the attack threshold a location must reach before it will be shown by IWD at all' 
		sliderThreshold:SetMinMaxValues(1,10);
		sliderThreshold:SetValueStep(1);
		sliderThreshold:SetOrientation('HORIZONTAL')
		sliderThreshold:SetValue(IWDConfiguration.THRESHOLD);
		getglobal(sliderThreshold:GetName() .. 'Text'):SetText(sliderThreshold:GetValue());
		sliderThreshold:Enable();
	end)
	-- OnValueChanged
	sliderThreshold:SetScript("OnValueChanged", function(frame)
		getglobal(sliderThreshold:GetName() .. 'Text'):SetText(sliderThreshold:GetValue());
		IWDConfiguration.THRESHOLD = sliderThreshold:GetValue();
		
	end)